=== debian/changelog ===
diamond-aligner (2.1.9-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Wed, 07 Feb 2024 11:17:49 +0100

diamond-aligner (2.1.8-2) unstable; urgency=medium

  [ Dandan Zhang ]
  * Add LoongArch support

 -- Andreas Tille <tille@debian.org>  Sat, 19 Aug 2023 11:56:22 +0200
