## diamond-aligner 2.1.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,6 @@
 option(SEQ_MASK "SEQ_MASK" ON)
 option(DP_STAT "DP_STAT" OFF)
 option(SINGLE_THREADED "SINGLE_THREADED" OFF)
-option(EIGEN_BLAS "EIGEN_BLAS" OFF)
 option(WITH_ZSTD "WITH_ZSTD" OFF)
 option(HIT_KEEP_TARGET_ID "HIT_KEEP_TARGET_ID" OFF)
 option(LONG_SEEDS "LONG_SEEDS" OFF)
@@ -39,7 +38,7 @@
   set(X86 OFF)
   # set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -maltivec")
   add_definitions(-DEIGEN_DONT_VECTORIZE)
-elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^s390")
+elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^s390|sparc")
   set(X86 OFF)
 endif()
 
@@ -133,6 +132,8 @@
   set_cxx_standard(11 "-std=gnu++11")
 endif()
 
+check_symbol_exists(sysinfo "sys/sysinfo.h" HAVE_SYSINFO)
+
 if(CMAKE_BUILD_MARCH)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=${CMAKE_BUILD_MARCH}")
 endif()
@@ -168,7 +169,6 @@
         "src/masking/tantan.cpp"
         "src/dp/scan_diags.cpp"
         "src/dp/ungapped_simd.cpp"
-        "src/dp/pfscan/pfscan.cpp"
         "src/dp/swipe/anchored_wrapper.cpp"
         "src/dp/score_profile.cpp"
         )
@@ -179,15 +179,11 @@
 
 add_library(arch_generic OBJECT ${DISPATCH_OBJECTS})
 target_compile_options(arch_generic PUBLIC -DDISPATCH_ARCH=ARCH_GENERIC -DARCH_ID=0 -DEigen=Eigen_GENERIC)
-target_include_directories(arch_generic PRIVATE "${CMAKE_SOURCE_DIR}/src/lib")
 if(X86)
   add_library(arch_sse4_1 OBJECT ${DISPATCH_OBJECTS})
-  target_include_directories(arch_sse4_1 PRIVATE "${CMAKE_SOURCE_DIR}/src/lib")
   add_library(arch_avx2 OBJECT ${DISPATCH_OBJECTS})
-  target_include_directories(arch_avx2 PRIVATE "${CMAKE_SOURCE_DIR}/src/lib")
   if(WITH_AVX512)
     add_library(arch_avx512 OBJECT ${DISPATCH_OBJECTS})
-    target_include_directories(arch_avx512 PRIVATE "${CMAKE_SOURCE_DIR}/src/lib")
   endif()
   add_definitions(-DWITH_AVX2)
   add_definitions(-DWITH_SSE4_1)
@@ -210,7 +206,6 @@
 if(AARCH64)
   add_definitions(-DWITH_NEON)
   add_library(arch_neon OBJECT ${DISPATCH_OBJECTS})
-  target_include_directories(arch_neon PRIVATE "${CMAKE_SOURCE_DIR}/src/lib")
   target_compile_options(arch_neon PUBLIC -DDISPATCH_ARCH=ARCH_NEON -DARCH_ID=4 -D__ARM_NEON -D__aarch64__ -DEigen=Eigen_NEON)
 endif(AARCH64)
 
@@ -223,7 +218,6 @@
     add_definitions(-DWITH_NEON)
     add_definitions(-DHAVE_MFPU_NEON)
     add_library(arch_neon OBJECT ${DISPATCH_OBJECTS})
-    target_include_directories(arch_neon PRIVATE "${CMAKE_SOURCE_DIR}/src/lib")
     target_compile_options(arch_neon PUBLIC -DDISPATCH_ARCH=ARCH_NEON -DARCH_ID=4 -D__ARM_NEON -DEigen=Eigen_NEON -mfpu=neon)
   endif()
   if(HAVE_GETAUXVAL)
@@ -239,7 +233,6 @@
         src/data/seed_histogram.cpp
         src/output/daa/daa_record.cpp
         src/util/command_line_parser.cpp
-        src/util/seq_file_format.cpp
         src/util/util.cpp
         src/basic/basic.cpp
         src/basic/hssp.cpp
@@ -247,8 +240,6 @@
         src/run/tools.cpp
         src/chaining/greedy_align.cpp
         src/output/output_format.cpp
-        src/output/clustering_variables.cpp
-        src/output/clustering_format.cpp
         src/output/join_blocks.cpp
         src/data/frequent_seeds.cpp
         src/align/legacy/query_mapper.cpp
@@ -280,18 +271,16 @@
         src/util/io/text_input_file.cpp
         src/data/taxon_list.cpp
         src/data/taxonomy_nodes.cpp
-        src/util/algo/MurmurHash3.cpp
+        src/lib/murmurhash/MurmurHash3.cpp
         src/search/stage0.cpp
         src/data/seed_array.cpp
         src/output/paf_format.cpp
         src/util/system/system.cpp
         src/util/algo/greedy_vertex_cover.cpp
         src/util/sequence/sequence.cpp
-        src/tools/tsv_record.cpp
         src/tools/tools.cpp
         src/util/system/getRSS.cpp
         src/lib/tantan/LambdaCalculator.cc
-        src/util/algo/edge_vec.cpp
         src/util/string/string.cpp
         src/align/extend.cpp
         src/test/test.cpp
@@ -351,3 +340,22 @@
         src/data/index.cpp
         src/data/dmnd/dmnd.cpp
         src/data/sequence_file.cpp
+        src/tools/find_shapes.cpp
+        src/data/block/block.cpp
+        src/data/block/block_wrapper.cpp
+        src/run/config.cpp
+        src/data/sequence_set.cpp
+        src/align/global_ranking/table.cpp
+        src/output/daa/daa_write.cpp
+        src/search/seed_complexity.cpp
+        src/util/tsv/tsv.cpp
+        src/basic/value.cpp
+        src/masking/motifs.cpp
+        src/align/alt_hsp.cpp
+        src/data/fasta/fasta_file.cpp
+        src/cluster/output.cpp
+        src/cluster/realign.cpp
+        src/cluster/reassign.cpp
+        src/util/tsv/read_tsv.cpp
+        src/tools/greedy_vertex_cover.cpp
+        src/cluster/cascaded/recluster.cpp
