=== debian/changelog ===
diamond-aligner (2.1.11-2) unstable; urgency=medium

  [ Gui-Yue ]
  * fix memcpy not defined on riscv64.  (Closes: #1099828)

 -- Étienne Mollier <emollier@debian.org>  Sun, 09 Mar 2025 10:47:09 +0100

diamond-aligner (2.1.11-1) unstable; urgency=medium

  * New upstream version 2.1.11
  * d/copyright: much needed copyright rehaul.
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: add myself to uploaders.
  * typo.patch: fix typo caught by lintian.

 -- Étienne Mollier <emollier@debian.org>  Fri, 07 Mar 2025 22:44:54 +0100

diamond-aligner (2.1.9-2) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * Exclude i386 build from Salsa CI

  [ Étienne Mollier ]
  * d/rules: remove use of ld.gold.
    ld.gold is deprecated and not part of binutils anymore, causing
    diamond-aligner to fail to build from source.
    Thanks to Michael R. Crusoe (Closes: #1095338)
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Sun, 16 Feb 2025 11:26:11 +0100
