=== debian/rules ===
--- 
+++ 
@@ -7,13 +7,6 @@
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 include /usr/share/dpkg/default.mk
-
-# Use the gold linker where we can
-ifeq (,$(filter $(DEB_HOST_ARCH),alpha hppa ia64 loong64 m68k riscv64 sh4))
-export LD=ld.gold
-export DEB_CFLAGS_MAINT_APPEND+=-fuse-ld=gold
-export DEB_CXXFLAGS_MAINT_APPEND+=-fuse-ld=gold
-endif
 
 ifeq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
 	EXTRA=-DX86=OFF
