## diamond-aligner 2.1.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,22 +1,25 @@
-cmake_minimum_required (VERSION 2.6)
+cmake_minimum_required (VERSION 2.6...3.5)
 project (DIAMOND)
 include(CheckCXXCompilerFlag)
 include(CheckSymbolExists)
 include(CheckTypeSize)
 
 option(BUILD_STATIC "BUILD_STATIC" OFF)
-option(EXTRA "EXTRA" OFF)
 option(STATIC_LIBGCC "STATIC_LIBGCC" OFF)
 option(STATIC_LIBSTDC++ "STATIC_LIBSTDC++" OFF)
 option(X86 "X86" ON)
 option(ARM "ARM" OFF)
 option(AARCH64 "AARCH64" OFF)
+option(WITH_ZSTD "WITH_ZSTD" OFF)
+option(CROSS_COMPILE "CROSS_COMPILE" OFF)
+
+# experimental options not suitable for deployment purposes
+option(EXTRA "EXTRA" OFF)
 option(STRICT_BAND "STRICT_BAND" ON)
 option(LEFTMOST_SEED_FILTER "LEFTMOST_SEED_FILTER" ON)
 option(SEQ_MASK "SEQ_MASK" ON)
 option(DP_STAT "DP_STAT" OFF)
 option(SINGLE_THREADED "SINGLE_THREADED" OFF)
-option(WITH_ZSTD "WITH_ZSTD" OFF)
 option(HIT_KEEP_TARGET_ID "HIT_KEEP_TARGET_ID" OFF)
 option(LONG_SEEDS "LONG_SEEDS" OFF)
 option(WITH_AVX512 "WITH_AVX512" OFF)
@@ -24,21 +27,22 @@
 option(WITH_MCL "WITH_MCL" OFF)
 option(WITH_MIMALLOC "WITH_MIMALLOC" OFF)
 option(USE_TLS "USE_TLS" OFF)
+
 set(MAX_SHAPE_LEN 19)
 set(BLAST_INCLUDE_DIR "" CACHE STRING "BLAST_INCLUDE_DIR")
 set(BLAST_LIBRARY_DIR "" CACHE STRING "BLAST_LIBRARY_DIR")
 
-if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64.*|AARCH64.*|arm64.*)")
+if(NOT CROSS_COMPILE AND CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64.*|AARCH64.*|arm64.*)")
   set(X86 OFF)
   set(AARCH64 ON)
-elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm.*|ARM.*)")
+elseif(NOT CROSS_COMPILE AND CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm.*|ARM.*)")
   set(X86 OFF)
   set(ARM ON)
-elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "PPC64*|ppc64*|powerpc64*")
+elseif(NOT CROSS_COMPILE AND CMAKE_SYSTEM_PROCESSOR MATCHES "PPC64*|ppc64*|powerpc64*")
   set(X86 OFF)
   # set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -maltivec")
   add_definitions(-DEIGEN_DONT_VECTORIZE)
-elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^s390|sparc")
+elseif(NOT CROSS_COMPILE AND CMAKE_SYSTEM_PROCESSOR MATCHES "^s390|sparc")
   set(X86 OFF)
 endif()
 
@@ -124,7 +128,10 @@
 
 check_cxx_compiler_flag("-std=gnu++14" HAS_GNUPP14)
 check_cxx_compiler_flag("-std=gnu++17" HAS_GNUPP17)
-if(HAS_GNUPP17 OR ${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
+check_cxx_compiler_flag("-std=gnu++20" HAS_GNUPP20)
+if(HAS_GNUPP20 OR ${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
+  set_cxx_standard(20 "-std=gnu++20")
+elseif(HAS_GNUPP17)
   set_cxx_standard(17 "-std=gnu++17")
 elseif (HAS_GNUPP14)
   set_cxx_standard(14 "-std=gnu++14")
@@ -179,6 +186,11 @@
 
 add_library(arch_generic OBJECT ${DISPATCH_OBJECTS})
 target_compile_options(arch_generic PUBLIC -DDISPATCH_ARCH=ARCH_GENERIC -DARCH_ID=0 -DEigen=Eigen_GENERIC)
+#target_compile_options(arch_generic PUBLIC -DDISPATCH_ARCH=ARCH_GENERIC -DARCH_ID=0)
+if (${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
+    target_compile_options(arch_generic PUBLIC /Zc:__cplusplus)
+endif()
+
 if(X86)
   add_library(arch_sse4_1 OBJECT ${DISPATCH_OBJECTS})
   add_library(arch_avx2 OBJECT ${DISPATCH_OBJECTS})
@@ -188,14 +200,18 @@
   add_definitions(-DWITH_AVX2)
   add_definitions(-DWITH_SSE4_1)
   if (${CMAKE_CXX_COMPILER_ID} STREQUAL MSVC)
-    target_compile_options(arch_sse4_1 PUBLIC -DDISPATCH_ARCH=ARCH_SSE4_1 -DARCH_ID=1 -D__SSSE3__ -D__SSE4_1__ -D__POPCNT__ -DEigen=Eigen_SSE4_1)
-    target_compile_options(arch_avx2 PUBLIC -DDISPATCH_ARCH=ARCH_AVX2 -DARCH_ID=2 /arch:AVX2 -D__SSSE3__ -D__SSE4_1__ -D__POPCNT__ -DEigen=Eigen_AVX2)
+    target_compile_options(arch_sse4_1 PUBLIC -DDISPATCH_ARCH=ARCH_SSE4_1 -DARCH_ID=1 -D__SSSE3__ -D__SSE4_1__ -D__POPCNT__ -DEigen=Eigen_SSE4_1 /Zc:__cplusplus)
+    target_compile_options(arch_avx2 PUBLIC -DDISPATCH_ARCH=ARCH_AVX2 -DARCH_ID=2 /arch:AVX2 -D__SSSE3__ -D__SSE4_1__ -D__POPCNT__ -DEigen=Eigen_AVX2 /Zc:__cplusplus)
+    #target_compile_options(arch_sse4_1 PUBLIC -DDISPATCH_ARCH=ARCH_SSE4_1 -DARCH_ID=1 -D__SSSE3__ -D__SSE4_1__ -D__POPCNT__ /Zc:__cplusplus)
+    #target_compile_options(arch_avx2 PUBLIC -DDISPATCH_ARCH=ARCH_AVX2 -DARCH_ID=2 /arch:AVX2 -D__SSSE3__ -D__SSE4_1__ -D__POPCNT__ /Zc:__cplusplus)
     if(WITH_AVX512)
       target_compile_options(arch_avx512 PUBLIC -DDISPATCH_ARCH=ARCH_AVX512 -DARCH_ID=3 /arch:AVX512 -D__SSSE3__ -D__SSE4_1__ -D__POPCNT__ -DEigen=Eigen_AVX512)
     endif()
   else()
     target_compile_options(arch_sse4_1 PUBLIC -DDISPATCH_ARCH=ARCH_SSE4_1 -DARCH_ID=1 -mssse3 -mpopcnt -msse4.1 -DEigen=Eigen_SSE4_1)
     target_compile_options(arch_avx2 PUBLIC -DDISPATCH_ARCH=ARCH_AVX2 -DARCH_ID=2 -mssse3 -mpopcnt -msse4.1 -msse4.2 -mavx -mavx2 -DEigen=Eigen_AVX2)
+    #target_compile_options(arch_sse4_1 PUBLIC -DDISPATCH_ARCH=ARCH_SSE4_1 -DARCH_ID=1 -mssse3 -mpopcnt -msse4.1)
+    #target_compile_options(arch_avx2 PUBLIC -DDISPATCH_ARCH=ARCH_AVX2 -DARCH_ID=2 -mssse3 -mpopcnt -msse4.1 -msse4.2 -mavx -mavx2)
     if(WITH_AVX512)
       target_compile_options(arch_avx512 PUBLIC -DDISPATCH_ARCH=ARCH_AVX512 -DARCH_ID=3 -mssse3 -mpopcnt -msse4.1 -msse4.2 -mavx -mavx2 -mavx512f -mavx512bw -DEigen=Eigen_AVX512)
     endif()
@@ -292,7 +308,7 @@
         src/cluster/cluster_registry.cpp
         src/cluster/cascaded/cascaded.cpp
         src/align/output.cpp
-        src/tools/roc.cpp
+        #src/tools/roc.cpp
         src/test/data.cpp
         src/test/test_cases.cpp
         src/chaining/smith_waterman.cpp
@@ -319,43 +335,13 @@
         src/lib/alp/sls_pvalues.cpp
         src/align/global_ranking/global_ranking.cpp
         src/align/global_ranking/extend.cpp
-        src/tools/rocid.cpp
+        #src/tools/rocid.cpp
         src/lib/blast/blast_seg.cpp
         src/lib/blast/blast_filter.cpp
         src/lib/blast/nlm_linear_algebra.cpp
-        src/stats/matrices/blosum45.cpp
-        src/stats/matrices/blosum50.cpp
-        src/stats/matrices/blosum62.cpp
-        src/stats/matrices/blosum80.cpp
-        src/stats/matrices/blosum90.cpp
-        src/stats/matrices/pam250.cpp
-        src/stats/matrices/pam30.cpp
-        src/stats/matrices/pam70.cpp
         src/stats/stats.cpp
         src/stats/cbs.cpp
         src/stats/comp_based_stats.cpp
         src/stats/hauser_correction.cpp
         src/stats/matrix_adjust.cpp
-        src/stats/matrix_adjust_eigen.cpp
         src/data/index.cpp
-        src/data/dmnd/dmnd.cpp
-        src/data/sequence_file.cpp
-        src/tools/find_shapes.cpp
-        src/data/block/block.cpp
-        src/data/block/block_wrapper.cpp
-        src/run/config.cpp
-        src/data/sequence_set.cpp
-        src/align/global_ranking/table.cpp
-        src/output/daa/daa_write.cpp
-        src/search/seed_complexity.cpp
-        src/util/tsv/tsv.cpp
-        src/basic/value.cpp
-        src/masking/motifs.cpp
-        src/align/alt_hsp.cpp
-        src/data/fasta/fasta_file.cpp
-        src/cluster/output.cpp
-        src/cluster/realign.cpp
-        src/cluster/reassign.cpp
-        src/util/tsv/read_tsv.cpp
-        src/tools/greedy_vertex_cover.cpp
-        src/cluster/cascaded/recluster.cpp
