=== debian/changelog ===
diamond-aligner (2.1.14-1) unstable; urgency=medium

  * Fix build with CMake 4
    Closes: #1112842
  * d/watch: version=5
  * New upstream version
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 17 Oct 2025 11:44:29 +0200
