=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- $(EXTRA) -DCMAKE_BUILD_TYPE=Release
+	dh_auto_configure -- $(EXTRA) -DCMAKE_BUILD_TYPE=Release -DCMAKE_POLICY_VERSION_MINIMUM=3.5
 
 override_dh_compress:
 	dh_compress --exclude=.pdf
