=== debian/watch ===
Version: 5

Template: Github
Owner: bbuchfink
Project: diamond
